/*!\file:  BamgMesh.h
 */ 

#ifndef BAMGMESH_H_
#define BAMGMESH_H_

struct BamgMesh{

	int     TrianglesSize[2];
	double* Triangles;

	int     VerticesSize[2];
	double* Vertices;

	int     EdgesSize[2];
	double* Edges;

	int     ElementEdgesSize[2];
	double* ElementEdges;

	int     SegmentsSize[2];
	double* Segments;

	int     CrackedEdgesSize[2];
	double* CrackedEdges;

	int     QuadrilateralsSize[2];
	double* Quadrilaterals;

	int     VerticesOnGeometricVertexSize[2];
	double* VerticesOnGeometricVertex;

	int     VerticesOnGeometricEdgeSize[2];
	double* VerticesOnGeometricEdge;

	int     EdgesOnGeometricEdgeSize[2];
	double* EdgesOnGeometricEdge;

	int     SubDomainsSize[2];
	double* SubDomains;

	int     SubDomainsFromGeomSize[2];
	double* SubDomainsFromGeom;

	double* hVertices;

	int     ElementConnectivitySize[2];
	double* ElementConnectivity;

	int     NodalConnectivitySize[2];
	double* NodalConnectivity;

	int     NodalElementConnectivitySize[2];
	double* NodalElementConnectivity;
};

void BamgMeshInit(BamgMesh* bamgmesh);

#ifdef _SERIAL_
#include "mex.h"
void BamgMeshWrite(mxArray** bamgmesh_mat,BamgMesh* bamgmesh);
#endif

#endif
